# How to Contribute

First of all, thank you for taking the time to contribute to Sabaki!

## Reporting Bugs

* Before submitting bug reports, please check the [issues](https://github.com/yishn/Sabaki/issues) for already existing reports. You might not need to create one.
* Use a clear and descriptive title.
* Please include as many details as possible in your issue, especially the version of Sabaki you're using and the name and version of the OS you're using.
* It's also helpful to provide specific steps to reproduce the problem.

## Code Contribution

* Before you begin, make sure there's an issue for your task and that you've let us known that you'd like to take it on.
* Make sure your code adheres to the code and style standards.
* Avoid platform-dependent code.
* Create mocha tests if possible and applicable.
* Document new code in the documentation if applicable.
* Note the issue number in your pull request.

## Documentation

The documentation is incomplete and I'll be thankful for anyone contributing to it. You can submit pull requests to:

* Fix typos.
* Add descriptions for things that need one.
* Add missing documentation.
* Add tutorials.

## Donate

You can also support this project by [donating](https://paypal.me/yishn/4).
