# Sabaki [![Build Status](https://travis-ci.org/yishn/Sabaki.svg?branch=master)](https://travis-ci.org/yishn/Sabaki)

<img src="logo.png" width="156" height="156">

An elegant Go/Baduk/Weiqi board and SGF editor for a more civilized age. [Download the latest release](https://github.com/yishn/Sabaki/releases) of Sabaki.

![Screenshot](screenshot.png)

## Features

- Fuzzy stone placement
- Read and save SGF games and collections
- Open wBaduk NGF and Tygem GIB files
- Display formatted SGF comments using a [subset of Markdown](https://github.com/yishn/Sabaki/wiki/Markdown-in-Sabaki)
- Personalize board appearance with [userstyles](https://github.com/yishn/Sabaki/wiki/Userstyles)
- SGF editing tools
- Lines & arrows board markup
- Copy & paste variations
- Fast game tree
- Score estimator & scoring tool
- Find move by move position and comment text
- Position & move annotations
- [GTP engines](https://github.com/yishn/Sabaki/wiki/Engines) support
- Guess mode
- Autoplay games

For more information visit the [wiki](https://github.com/yishn/Sabaki/wiki). You're welcome to [contribute](https://github.com/yishn/Sabaki/blob/master/CONTRIBUTING.md) to this project.

## Web Version

Sabaki has a [`web`](https://github.com/yishn/Sabaki/tree/web) branch. It's a trimmed-down version of Sabaki that runs in any modern browser. You can try a [working demo here](http://sabaki.yichuanshen.de/web/).

If you're looking for the code of the [website](http://sabaki.yichuanshen.de/), you can find it in [this repository](https://github.com/yishn/sabaki-website).

## Documentation

The documentation is located in the [docs](https://github.com/yishn/Sabaki/blob/master/docs) directory.

## Building & Tests

See [Building & Tests](https://github.com/yishn/Sabaki/wiki/Building-&-Tests/ea894af79e68b32c31875ea616ac914717e337fe) in the wiki.

## License

This project is licensed under the [MIT license](https://github.com/yishn/Sabaki/blob/master/LICENSE.md).
