# Helper

The `helper` module consists of helper functions needed by almost all other Sabaki modules. To access this module use:

~~~js
const {helper} = sabaki.modules
~~~

## Methods

### helper.getId()

Returns an integer that is unique among all integers generated by `helper.getId()` during the runtime of Sabaki.

### helper.clone(data)

* `data` `<Object>` | `<Array>`

Creates a deep copy of `data`.

### helper.hash(str)

* `str` `<String>`

### helper.equals(a, b)

Checks for deep equality.

### helper.shallowEquals(a, b)

* `a` `<Array>`
* `b` `<Array>`

Checks for shallow equality of two arrays.

### helper.vertexEquals(a, b)

* `a` [`<Vertex>`](vertex.md)
* `b` [`<Vertex>`](vertex.md)

Checks whether the given vertices are equal.

### helper.lexicalCompare(a, b)

* `a` `<Array>`
* `b` `<Array>`

Performs a shallow lexical comparison between two arrays. Returns `-1` iff `a < b`, `1` iff `a > b`, and `0` otherwise.

### helper.normalizeEndings(input)

* `input` `<String>`

Converts `'\r\n'`, `'\n\r'`, and `'\r'` into simple linebreaks `'\n'`.

### helper.markdown(input)

* `input` `<String>`

Returns the HTML according to [Sabaki's Markdown rules](https://github.com/yishn/Sabaki/wiki/Markdown-in-Sabaki).
